package com.prowidesoftware.brilliance.mx2mt;

import com.prowidesoftware.brilliance.constants.Mx2MtConstants;
import com.prowidesoftware.brilliance.exception.SwiftException;
import com.prowidesoftware.brilliance.util.StringUtil;
import com.prowidesoftware.brilliance.util.XmlUtil;
import com.prowidesoftware.swift.model.mx.dic.CashAccount16;
import com.prowidesoftware.swift.model.mx.dic.GenericAccountIdentification1;
import org.dom4j.Document;

import java.util.Map;

public abstract class AbstractMx2MtFieldsGenerate implements Mx2MtFieldsGenerate {

    protected Map<String, Object> map = null;

    protected void withMap(Map<String, Object> targetMap) {
        map = targetMap;
    }

    protected String getXmlNodeValue(String type, Document document, String path) {
        String parentPath = (String)map.get(type);
        if (StringUtil.isNotEmpty(parentPath)) {
            path = parentPath + "." + path;
        }
        return XmlUtil.getXmlNodeValue(document, path);
    }

    protected int getXmlNodeCounts(String type, Document document, String path) {
        String parentPath = (String)map.get(type);
        if (StringUtil.isNotEmpty(parentPath)) {
            path = parentPath + "." + path;
        }
        return XmlUtil.getChildrenCount(document, path, null);
    }

    protected String getMtFormatAccount(CashAccount16 dbtrAcct) {
        String account = "";
        String iban = "";
        String otherId = "";
        if (dbtrAcct != null) {
            if (dbtrAcct.getId() != null) {
                iban = dbtrAcct.getId().getIBAN();
                if (StringUtil.isEmpty(iban)) {
                    GenericAccountIdentification1 othr = dbtrAcct.getId().getOthr();
                    if (othr != null) {
                        if (othr.getSchmeNm() != null) {
                            otherId = othr.getSchmeNm().getCd();
                        }
                        if (StringUtil.isEmpty(otherId)) {
                            otherId = othr.getId();
                        }
                    }
                }
            }
        }
        if (!StringUtil.isEmpty(iban)) {
            account = "/"+iban;
        } else if (!StringUtil.isEmpty(otherId)) {
            account = "//CH"+otherId;
        }
        return account;
    }
}
