package com.prowidesoftware.brilliance.mx2mt.mt103.impl;

import com.prowidesoftware.brilliance.constants.Mx2MtConstants;
import com.prowidesoftware.brilliance.exception.SwiftException;
import com.prowidesoftware.brilliance.mx2mt.AbstractMx2MtFieldsGenerate;
import com.prowidesoftware.brilliance.util.StringUtil;
import org.dom4j.Document;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class Field36Generate extends AbstractMx2MtFieldsGenerate {
    private static final Logger logger = LoggerFactory.getLogger(Field36Generate.class);
    @Override
    public void fieldsGenerate() throws SwiftException {
        try {
            String field36 = "";
            Document document = (Document)map.get(Mx2MtConstants.MX_XML_DOCUMENT);
            String exchangeRate = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "CdtTrfTxInf.XchgRate");
            if (StringUtil.isNotEmpty(exchangeRate)) {
                field36 = exchangeRate.replace(".", ",");
            }
            map.put("field36",field36);
        } catch (Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}
