package com.prowidesoftware.brilliance.mx2mt.mt103.impl;

import com.prowidesoftware.brilliance.constants.Mx2MtConstants;
import com.prowidesoftware.brilliance.exception.SwiftException;
import com.prowidesoftware.brilliance.mx2mt.AbstractMx2MtFieldsGenerate;
import com.prowidesoftware.brilliance.util.StringUtil;
import org.dom4j.Document;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * 取此节点按4*35的格式拆分，放入70栏位中
 * <CdtTrfTxInf>[1]<RmtInf><Ustrd>[1]
 */
public class Field70Generate extends AbstractMx2MtFieldsGenerate {
    private static final Logger logger = LoggerFactory.getLogger(com.prowidesoftware.brilliance.mx2mt.mt103.impl.Field70Generate.class);
    @Override
    public void fieldsGenerate() throws SwiftException {
        try {
            String field70 = "";
            Document document = (Document)map.get(Mx2MtConstants.MX_XML_DOCUMENT);
            int ustrdCounts = getXmlNodeCounts(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "CdtTrfTxInf.RmtInf.Ustrd");
            if (ustrdCounts > 0) {
                String ustrd = getXmlNodeValue(Mx2MtConstants.MAINBODY_PARENT_ELEMENT_NAME, document, "CdtTrfTxInf.RmtInf.Ustrd(0)");
                field70 = StringUtil.getStringByEnter(ustrd, 35, 4);
            }
            map.put("field70", field70);
        } catch (Exception e) {
            throw new SwiftException("ERROR", e.getMessage());
        }
    }
}